import { AuthenticateCustomerPayload, Project, SimpleProjectInfo } from '../types/common';
import { GraphQLClient } from 'graphql-request';
import { Config } from '../Config';
import { Environment, Cluster } from 'graphcool-yml';
import { Output } from '../index';
export declare class Client {
    config: Config;
    env: Environment;
    out: Output;
    mock: (input: {
        request: any;
        response: any;
    }) => void;
    private mocks;
    private tokenCache;
    constructor(config: Config, environment: Environment, out: Output);
    getClient(cluster: Cluster): GraphQLClient;
    readonly client: GraphQLClient;
    introspect(serviceName: string, stageName: string, token?: string): Promise<any>;
    exec(serviceName: string, stageName: string, query: string, token?: string): Promise<any>;
    download(serviceName: string, stage: string, exportData: any, token?: string): Promise<any>;
    upload(serviceName: string, stage: string, exportData: any, token?: string): Promise<any>;
    reset(serviceName: string, stage: string, token?: string): Promise<void>;
    addProject(name: string, stage: string, secrets: string[] | null): Promise<SimpleProjectInfo>;
    deploy(name: string, stage: string, types: string, dryRun: boolean, secrets: string[] | null): Promise<any>;
    listProjects(): Promise<Project[]>;
    getProject(name: string, stage: string): Promise<Project | null>;
    getCluster(name: string, stage: string): Promise<Cluster | null>;
    getClusterSafe(name: string, stage: string): Promise<Cluster>;
    waitForLocalDocker(endpoint: string): Promise<void>;
    waitForMigration(name: string, stage: string, revision: number): Promise<void>;
    authenticateCustomer(endpoint: string, token: string): Promise<AuthenticateCustomerPayload>;
}
