import { RunOptions } from './types/common';
import { Output } from './Output/index';
export declare class Config {
    /**
     * Local settings
     */
    out: Output;
    debug: boolean;
    windows: boolean;
    bin: string;
    mock: boolean;
    argv: string[];
    commandsDir: string;
    defaultCommand: string;
    userPlugins: boolean;
    version: string;
    name: string;
    pjson: any;
    /**
     * Paths
     */
    cwd: string;
    home: string;
    root: string;
    definitionDir: string;
    definitionPath: string | null;
    globalGraphcoolPath: string;
    globalConfigPath: string;
    globalClusterCachePath: string;
    warnings: string[];
    /**
     * Urls
     */
    statusEndpoint: string;
    __cache: {};
    constructor(options?: RunOptions);
    setOutput(out: Output): void;
    readonly arch: string;
    readonly platform: string;
    readonly userAgent: string;
    readonly dirname: any;
    readonly cacheDir: string;
    readonly requireCachePath: string;
    readonly requestsCachePath: string;
    private readPackageJson(options);
    private setPaths();
    private warn(msg);
    private setDefinitionPaths();
    private getCwd();
    private getHome();
}
