import { Args, GraphcoolModule, ProjectDefinition } from '../types/common';
import { Output } from '../Output/index';
import { Config } from '../Config';
import { FunctionDefinition } from 'graphcool-json-schema';
export interface FunctionTuple {
    name: string;
    fn: FunctionDefinition;
}
export declare class ProjectDefinitionClass {
    static sanitizeDefinition(definition: ProjectDefinition): {
        modules: {
            name: string;
            content: string;
            files: {
                [fileName: string]: string;
            };
            externalFiles: any;
        }[];
    };
    definition: ProjectDefinition | null;
    out: Output;
    config: Config;
    args: Args;
    constructor(out: Output, config: Config);
    load(args: Args): Promise<void>;
    save(files?: string[], silent?: boolean): Promise<void>;
    saveTypes(): Promise<void>;
    set(definition: ProjectDefinition | null): void;
    getFunctionAndModule(name: string): {
        fn: FunctionDefinition;
        module: GraphcoolModule;
    } | null;
    insertModule(moduleName: string, relativePath: string): string;
    comment(str: string): string;
    addTemplateNotes(str: string, templateName: string): string;
    mergeDefinition(newDefinitionYaml: string, templateName: string, useComments?: boolean): string;
    mergeTypes(newTypes: string, templateName: string): string;
    checkNodeModules(throwError: boolean): Promise<void>;
    private injectEnvironmentToFile(file, environment);
    private insertToDefinition(file, key, insertion);
    private extractValues(file, obj, key, valuesOnly);
    private getBeginningPosition(file, key);
    readonly functions: FunctionTuple[];
    private extractFunctions(functions?);
}
